/*
	Regiongrowing.ijm
	Simple threshold-based region-growing script for ImageJ with DICOM Images
	(c)2009 B. Schwarz / P. Grieger
*/
//VARS
var maxBorder = 28; 
var minBorder = -28;
var gMin; 
var gMax;
var gHeight = getHeight(); 
var gWidth = getWidth(); 
var gID = getImageID(); 
var bufferID; 

//FUNCTIONS
	//this does the region growing
	function growRegion(gX,gY)
	{
		/*(very) Verbose Mode Growing*/
		//print("Growing Region around:"+x+" "+y+" from ID "+gID+" buffering to "+bufferID+" .");
		//print("Using "+gMin+" and "+gMax+" as threshold Values."+getPixel(gX,gY));
		if(getPixel(gX,gY)>=gMin && getPixel(gX,gY)<=gMax && hasLabel(gX,gY) != 1)
		{
			//print("New seedpoint set!");
			setLabel(gX,gY);
			growRegion(gX-1,gY);
			growRegion(gX,gY-1);
			growRegion(gX+1,gY);
			growRegion(gX,gY+1);
		}
	}	
	
	//returns the label status of a pixel in the buffer
	function hasLabel(x,y) 
	{
		selectImage(bufferID);
		if (getPixel(x,y) == 255){
			selectImage(gID);
			return 1;
		}
		else{
			selectImage(gID);
			return 0;
		}
	}
	
	//this labels a Pixel of the region in the Buffer!
	function setLabel(x,y) 
	{
		selectImage(bufferID);
		setPixel(x,y,255);
		selectImage(gID);
	}
	
//IMAGEJ
   macro "Region Growing - C0a0L18f8L818f" {
		getCursorLoc(x, y, z, flags);
		gMax = maxBorder+getPixel(x,y);
		gMin = minBorder+getPixel(x,y);
		// print("Sample: "+x+" "+y+" "+flags); //Verbose clicking
		newImage("buffer", "8-bit Black", gWidth, gHeight, 1); //creates a new, black buffer image
		bufferID = getImageID();
		selectImage(gID);
		growRegion(x,y);
    }

//IMAJEG OPTIONS - not necessary
	/*macro "Region Growing Options" { //Dialogs to set the Options (thresholds)
       	getNumber("Upper Threshold: ",maxBorder);
		getNumber("Lower Threshold: ", minBorder);
    }*/